/* $Id: clc_strcasestr.c,v 1.2 2003/06/08 11:55:40 augestad Exp $ */
/*
 * Copyright(c) 2003, B. Augestad, boa@metasystems.no
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <ctype.h>
#include <string.h>
#include "clc_assert.h"
#include "clc_string.h"

char* clc_strcasestr(const char *haystack, const char *needle)
{
    size_t cb1, cb2;
    const char *start, *stop, *org_needle = needle;
    int c1, c2;

    clc_assert_not_null(clc_strcasestr, haystack);
    clc_assert_not_null(clc_strcasestr, needle);

    /* The standard says that empty needles, "", returns haystack. */
    cb2 = strlen(needle);
    if(cb2 == 0)
        return (char*)haystack;

    /* No point in finding needles bigger than haystack */
    cb1 = strlen(haystack);
    if(cb2 > cb1) 
        return NULL;

    /* Compute the last starting point of a possible match */
    start = haystack;
    stop = start + cb1 - cb2;

    /* Now compare strings */
	for(;start <= stop; start++) {
        needle = org_needle;
        haystack = start;
        do {
            c2 = tolower((unsigned char)*needle++);

            /* If end of needle */
            if (c2 == '\0')
                return (char*)start;

            c1 = tolower((unsigned char)*haystack++);
        } while (c1 == c2);
    }

    return NULL;
}

