/* $Id: clc_strrtrim.c,v 1.4 2003/04/02 17:13:07 hfuru Exp $ */
/*
 * Copyright (c) 2003 Eric G. Miller <egm2@jps.net>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <string.h>
#include <ctype.h>
#include "clc_assert.h"
#include "clc_string.h"

/*
 * This function modifies its argument and returns a pointer to the
 * argument passed.
 *
 * Trim whitespace from the right of the string.
 */

char *clc_strrtrim(char *s)
{
	size_t len;

	clc_assert_not_null(clc_strrtrim, s);

	len = strlen(s);
	while (len && isspace((unsigned char)s[len-1])) {
		len--;
	}

	s[len] = '\0';
	return s;
}
