/* $Id: clc_strsep.c,v 1.3 2003/03/30 13:02:39 hfuru Exp $ */
/*
 * Copyright (C) 2003, Hallvard B. Furuseth <h.b.furuseth@usit.uio.no>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <string.h>
#include "clc_string.h"
#include "clc_assert.h"


char *
clc_strsep(char **CLC_RESTRICT stringp, const char *CLC_RESTRICT delim)
{
	char *str, *end;
	clc_assert_not_null(clc_strsep, delim);
	clc_assert_arg(clc_strsep, stringp != NULL && *stringp != NULL);
	str = *stringp + strspn(*stringp, delim);
	if (*str == '\0') {
		end = str;
		str = NULL;
	} else {
		end = str + strcspn(str, delim);
		if (*end != '\0')
			*end++ = '\0';
	}
	*stringp = end;
	return str;
}

char *
clc_strtok_r(char *str, const char *CLC_RESTRICT delim, char **tracker)
{
	clc_assert_not_null(clc_strtok_r, delim);
	clc_assert_not_null(clc_strtok_r, tracker);
	clc_assert_arg(clc_strtok_r, str != NULL || *tracker != NULL);
	if (str != NULL)
		*tracker = str;
	return clc_strsep(tracker, delim);
}
