/* $Id: clc_strsub.c,v 1.3 2003/05/01 12:09:22 hfuru Exp $ */
/*
 * Copyright (C) 2003 Hallvard B. Furuseth <h.b.furuseth@usit.uio.no>
 * COPYING RESTRICTIONS APPLY, see COPYING file.
 */

#include <string.h>
#include "clc_assert.h"
#include "clc_string.h"


char *
clc_strsub(
	char *CLC_RESTRICT dest,
	char *CLC_RESTRICT src,
	size_t offset,
	size_t len)
{
	clc_assert_not_null(clc_strsub, dest);
	clc_assert_not_null(clc_strsub, src);
	*dest = '\0';
	if (!memchr(src, '\0', offset))
		strncat(dest, src + offset, len);
	return dest;
}

char *
clc_strleft(char *CLC_RESTRICT dest, char *CLC_RESTRICT src, size_t len)
{
	clc_assert_not_null(clc_strleft, dest);
	clc_assert_not_null(clc_strleft, src);
	*dest = '\0';
	strncat(dest, src, len);
	return dest;
}

char *
clc_strright(char *CLC_RESTRICT dest, char *CLC_RESTRICT src, size_t len)
{
	size_t src_len;
	clc_assert_not_null(clc_strsub, dest);
	clc_assert_not_null(clc_strsub, src);
	src_len = strlen(src);
	if(src_len > len)
		src += src_len - len;
	return strcpy(dest, src);
}
